package com.fr.data;

package ..deTemp.1740621024250;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.alibaba.fastjson.support.config.FastJsonConfig;
import com.alibaba.fastjson.support.spring.FastJsonHttpMessageConverter;
import com.fr.data.SimpleTableData;
import com.fr.stable.ParameterProvider;
import java.math.BigDecimal;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.http.client.ClientHttpRequestFactory;
import org.springframework.http.client.SimpleClientHttpRequestFactory;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.web.client.RestTemplate;

public class QueryBalance extends SimpleTableData {
  public String[] initColumnNames() {
    return new String[] { 
        "branchCode", "projectId", "projectName", "productId", "subProductId", "paymentId", "period", "status", "balance", "paymentDate", 
        "toFundDate", "fundToSpecialDate", "refundDate", "first_type", "first_amount", "first_rate", "first_rateDays", "first_interest", "second_type", "second_amount", 
        "second_rate", "second_rateDays", "second_interest", "third_type", "third_amount", "third_rate", "third_rateDays", "third_interest" };
  }
  
  public List<Object[]> loadData() {
    String env = ((ParameterProvider)((Collection)this.parameters.get()).toArray()[0]).getValue().toString();
    String deadlineDate = ((ParameterProvider)((Collection)this.parameters.get()).toArray()[1]).getValue().toString();
    String projectId = ((ParameterProvider)((Collection)this.parameters.get()).toArray()[2]).getValue().toString();
    String branchCode = ((ParameterProvider)((Collection)this.parameters.get()).toArray()[3]).getValue().toString();
    String status = ((ParameterProvider)((Collection)this.parameters.get()).toArray()[4]).getValue().toString();
    String url = "/sinosure-center/view/balance/query";
    String reqUrl = env + url;
    List<Object[]> valueList = new ArrayList();
    Map<String, Object> body = new HashMap<>();
    body.put("deadlineDate", deadlineDate);
    body.put("projectId", projectId);
    body.put("branchCode", branchCode);
    body.put("status", status);
    JSONObject jsonObject = sendRequest(reqUrl, body);
    System.out.println(jsonObject.get("msg"));
    JSONArray jsonArray = jsonObject.getJSONArray("data");
    for (Object o : jsonArray) {
      JSONObject item = (JSONObject)o;
      Object item_branchCode = item.get("branchCode");
      Object item_projectId = item.get("projectId");
      Object item_projectName = item.get("projectName");
      Object item_productId = item.get("productId");
      Object item_subProductId = item.get("subProductId");
      Object item_paymentId = item.get("paymentId");
      Object item_period = item.get("period");
      Object item_status = item.get("status");
      Object item_balance = item.get("balance");
      Object item_paymentDate = item.get("paymentDate");
      Object item_toFundDate = item.get("toFundDate");
      Object item_fundToSpecialDate = item.get("fundToSpecialDate");
      Object item_refundDate = item.get("refundDate");
      Object first_type = null;
      Object first_amount = null;
      Object first_rate = null;
      Object first_rateDays = null;
      Object first_interest = null;
      Object second_type = null;
      Object second_amount = null;
      Object second_rate = null;
      Object second_rateDays = null;
      Object second_interest = null;
      Object third_type = null;
      Object third_amount = null;
      Object third_rate = null;
      Object third_rateDays = null;
      Object third_interest = null;
      JSONArray interests = item.getJSONArray("interests");
      for (Object interest : interests) {
        JSONObject interest_item = (JSONObject)interest;
        if (interest_item.get("type").equals("FIRST")) {
          first_type = interest_item.get("type");
          first_amount = interest_item.get("amount");
          first_rate = interest_item.get("rate");
          first_rateDays = interest_item.get("rateDays");
          if (first_interest != null) {
            first_rate = "-";
            first_rateDays = "-";
            first_interest = (new BigDecimal(interest_item.get("interest").toString())).add(new BigDecimal(first_interest.toString()));
          } else {
            first_interest = interest_item.get("interest");
          } 
        } 
        if (interest_item.get("type").equals("SECOND")) {
          second_type = interest_item.get("type");
          second_amount = interest_item.get("amount");
          second_rate = interest_item.get("rate");
          second_rateDays = interest_item.get("rateDays");
          if (second_interest != null) {
            second_rate = "-";
            second_rateDays = "-";
            second_interest = (new BigDecimal(interest_item.get("interest").toString())).add(new BigDecimal(second_interest.toString()));
          } else {
            second_interest = interest_item.get("interest");
          } 
        } 
        if (interest_item.get("type").equals("THIRD")) {
          third_type = interest_item.get("type");
          third_amount = interest_item.get("amount");
          third_rate = interest_item.get("rate");
          third_rateDays = interest_item.get("rateDays");
          if (third_interest != null) {
            third_rate = "-";
            third_rateDays = "-";
            third_interest = (new BigDecimal(interest_item.get("interest").toString())).add(new BigDecimal(third_interest.toString()));
            continue;
          } 
          third_interest = interest_item.get("interest");
        } 
      } 
      valueList.add(new Object[] { 
            item_branchCode, item_projectId, item_projectName, item_productId, item_subProductId, item_paymentId, item_period, item_status, item_balance, item_paymentDate, 
            item_toFundDate, item_fundToSpecialDate, item_refundDate, first_type, first_amount, first_rate, first_rateDays, first_interest, second_type, second_amount, 
            second_rate, second_rateDays, second_interest, third_type, third_amount, third_rate, third_rateDays, third_interest });
    } 
    return valueList;
  }
  
  JSONObject sendRequest(String reqUrl, Map<String, Object> body) {
    HttpHeaders headers = new HttpHeaders();
    headers.setContentType(MediaType.APPLICATION_JSON_UTF8);
    HttpEntity<String> requestEntity = new HttpEntity(JSON.toJSONString(body), (MultiValueMap)headers);
    LinkedMultiValueMap linkedMultiValueMap = new LinkedMultiValueMap();
    ResponseEntity<JSONObject> responseEntity = buildRest().exchange(reqUrl, HttpMethod.POST, requestEntity, JSONObject.class, (Map)linkedMultiValueMap);
    JSONObject result = (JSONObject)responseEntity.getBody();
    return result;
  }
  
  RestTemplate buildRest() {
    SimpleClientHttpRequestFactory requestFactory = new SimpleClientHttpRequestFactory();
    requestFactory.setConnectTimeout(20000);
    requestFactory.setReadTimeout(20000);
    RestTemplate rest = new RestTemplate((ClientHttpRequestFactory)requestFactory);
    FastJsonHttpMessageConverter fastConverter = new FastJsonHttpMessageConverter();
    FastJsonConfig fastJsonConfig = new FastJsonConfig();
    fastJsonConfig.setSerializerFeatures(new SerializerFeature[] { SerializerFeature.PrettyFormat });
    fastConverter.setFastJsonConfig(fastJsonConfig);
    fastConverter.setDefaultCharset(Charset.forName("UTF-8"));
    FastJsonHttpMessageConverter fastJsonHttpMessageConverter1 = fastConverter;
    rest.getMessageConverters().add(fastJsonHttpMessageConverter1);
    return rest;
  }
}
